From b5413e5c202b1b2c79d68ff97f5f49ff43bfce5a Mon Sep 17 00:00:00 2001
From: Jiri Gaisler <jiri@gaisler.se>
Date: Wed, 18 Feb 2015 23:10:51 +0100
Subject: [PATCH 10/11] sim/erc32: Updated documentation.

	Cleaned up documentation. Obsolote README files were removed,
	main documentation on operation is now in READMEM.sis.
---
 sim/erc32/NEWS         | 108 --------------------
 sim/erc32/README.erc32 |  88 ++++++++++++----
 sim/erc32/README.gdb   |  67 ------------
 sim/erc32/README.leon2 |  53 ++++++++++
 sim/erc32/README.sis   | 271 ++++++++++++++++++-------------------------------
 sim/erc32/erc32.c      |   2 +-
 sim/erc32/interf.c     |   2 +-
 sim/erc32/leon2.c      |   2 +-
 sim/erc32/leon3.c      |   2 +-
 sim/erc32/sis.c        |   2 +-
 sim/erc32/startsim     |  18 ----
 11 files changed, 225 insertions(+), 390 deletions(-)
 delete mode 100644 sim/erc32/NEWS
 delete mode 100644 sim/erc32/README.gdb
 create mode 100644 sim/erc32/README.leon2
 delete mode 100644 sim/erc32/startsim

diff --git a/sim/erc32/README.erc32 b/sim/erc32/README.erc32
index f413599..831434f 100644
--- a/sim/erc32/README.erc32
+++ b/sim/erc32/README.erc32
@@ -8,26 +8,26 @@ The following paragraphs outline the implemented MEC functions.
 1.1 UARTs
 
 The UARTs are connected to two pseudo-devices, /dev/ttypc and /dev/ttypd.
-The following registers are implemeted:
+The following registers are implemented:
 
 - UART A RX and TX register	(0x01f800e0)
 - UART B RX and TX register	(0x01f800e4)
 - UART status register		(0x01f800e8)
 
-To speed up simulation, the UARTs operate at approximately 115200 baud. 
-The UARTs generate interrupt 4 and 5 after each received or transmitted 
+To speed up simulation, the UARTs operate at approximately 115200 baud.
+The UARTs generate interrupt 4 and 5 after each received or transmitted
 character.  The error interrupt is generated if overflow occurs - other
-errors cannot occure.
+errors cannot occur.
 
-1.2 Real-time clock and general pupose timer A
+1.2 Real-time clock and general purpose timer A
 
-The following registers are implemeted:
+The following registers are implemented:
 
 - Real-time clock timer				(0x01f80080, read-only)
 - Real-time clock scaler program register 	(0x01f80084, write-only)
 - Real-time clock counter program register 	(0x01f80080, write-only)
 
-- Genearl pupose timer 				(0x01f80088, read-only)
+- General purpose timer 				(0x01f80088, read-only)
 - Real-time clock scaler program register 	(0x01f8008c, write-only)
 - General purpose timer counter prog. register 	(0x01f80088, write-only)
 
@@ -42,7 +42,7 @@ only internal interrupts that are generated are the real-time clock,
 the general purpose timer and UARTs. However, all 15 interrupts
 can be tested via the interrupt force register.
 
-The following registers are implemeted:
+The following registers are implemented:
 
 - Interrupt pending register		       (0x01f80048, read-only)
 - Interrupt mask register		       (0x01f8004c, read-write)
@@ -53,13 +53,13 @@ The following registers are implemeted:
 
 The breakpoint and watchpoint functions are implemented as in the MEC
 specification. Traps are correctly generated, and the system fault status
-register is updated accordingly. Implemeted registers are:
+register is updated accordingly. Implemented registers are:
 
 - Debug control register			(0x01f800c0, read-write)
 - Breakpoint register				(0x01f800c4, write-only)
 - Watchpoint register				(0x01f800c8, write-only)
 - System fault status register			(0x01f800a0, read-write)
-- Firts failing address register		(0x01f800a4, read-write)
+- First failing address register		(0x01f800a4, read-write)
 
 
 1.5 Memory interface
@@ -67,29 +67,29 @@ register is updated accordingly. Implemeted registers are:
 The following memory areas are valid for the ERC32 simulator:
 
 0x00000000 - 0x00080000		ROM (512 Kbyte, loaded at start-up)
-0x02000000 - 0x02400000		RAM (4 Mbyte, initialised to 0x0)
+0x02000000 - 0x02400000		RAM (4 Mbyte, initialized to 0x0)
 0x01f80000 - 0x01f800ff		MEC registers
 
 Access to unimplemented MEC registers or non-existing memory will result
 in a memory exception trap. However, access to unimplemented MEC registers
 in the area 0x01f80000 - 0x01f80100 will not cause a memory exception trap.
 The written value will be stored in a register and can be read back. It
-does however not affect the function in any way. 
+does however not affect the function in any way.
 
-The memory configuartion register is used to define available memory
+The memory configuration register is used to define available memory
 in the system. The fields RSIZ and PSIZ are used to set RAM and ROM
-size, the remaining fields are not used.  NOTE: after reset, the MEC 
-is set to decode 4 Kbyte of ROM and 256 Kbyte of RAM. The memory 
-configuration register has to be updated to reflect the available memory. 
+size, the remaining fields are not used.  NOTE: after reset, the MEC
+is set to decode 4 Kbyte of ROM and 256 Kbyte of RAM. The memory
+configuration register has to be updated to reflect the available memory.
 
-The waitstate configuration register is used to generate waitstates. 
-This register must also be updated with the correct configuration after 
+The waitstate configuration register is used to generate waitstates.
+This register must also be updated with the correct configuration after
 reset.
 
 The memory protection scheme is implemented - it is enabled through bit 3
 in the MEC control register.
 
-The following registers are implemeted:
+The following registers are implemented:
 
 - MEC control register (bit 3 only)		(0x01f80000, read-write)
 - Memory control register			(0x01f80010, read-write)
@@ -100,10 +100,10 @@ The following registers are implemeted:
 1.6 Watchdog
 
 The watchdog is implemented as in the specification. The input clock is
-always the system clock regardsless of WDCS bit in mec configuration 
+always the system clock regardless of WDCS bit in mec configuration
 register.
 
-The following registers are implemeted:
+The following registers are implemented:
  
 - Watchdog program and acknowledge register	(0x01f80060, write-only)
 - Watchdog trap door set register		(0x01f80064, write-only)
@@ -128,3 +128,49 @@ Bit	Name	Function
 1	SWR	Soft reset enable
 3	APR	Access protection enable
 
+1.10 IU and FPU instruction timing.
+
+The simulator provides cycle true simulation for ERC32. The following table
+shows the emulated instruction timing for 90C601E & 90C602E:
+
+Instructions	      Cycles
+
+jmpl, rett		2
+load			2
+store			3
+load double		3
+store double		4
+other integer ops	1
+fabs			2
+fadds			4
+faddd			4
+fcmps			4
+fcmpd			4
+fdivs			20
+fdivd			35
+fmovs			2
+fmuls			5
+fmuld			9
+fnegs			2
+fsqrts			37
+fsqrtd			65
+fsubs			4
+fsubd			4
+fdtoi			7
+fdots			3
+fitos			6
+fitod			6
+fstoi			6
+fstod			2
+
+The parallel operation between the IU and FPU is modelled. This means
+that a FPU instruction will execute in parallel with other instructions as
+long as no data or resource dependency is detected. See the 90C602E data
+sheet for the various types of dependencies. Tracing using the 'trace'
+command will display the current simulator time in the left column. This
+time indicates when the instruction is fetched. If a dependency is detected,
+the following fetch will be delayed until the conflict is resolved.
+
+The load dependency in the 90C601E is also modelled - if the destination
+register of a load instruction is used by the following instruction, an
+idle cycle is inserted.
diff --git a/sim/erc32/README.leon2 b/sim/erc32/README.leon2
new file mode 100644
index 0000000..c79a4e3
--- /dev/null
+++ b/sim/erc32/README.leon2
@@ -0,0 +1,53 @@
+
+1. LEON2 emulation
+
+The file 'leon2.c' contains a model of simple LEON2 sub-system. It
+contains 16 Mbyte ROM and 16 Mbyte RAM. Standard peripherals
+such as interrupt controller, UART and timer are provided.
+The model can execute leon2 binaries that do not require an
+MMU.
+
+To start sis in Leon2 mode, add the -leon2 switch. In gdb,
+use 'target sim -leon2' .
+
+1.1 UART
+
+One LEON2 UART is emulated, and is located at address 0x80000070.
+The following registers are implemented:
+
+- UART RX and TX register	(0x80000070)
+- UART status register		(0x80000074)
+
+The UART generates interrupt 3.
+
+1.2 Timer unit
+
+The LEON2 timer unit is emulated and located at address 0x80000040.
+It is configured with two timers and separate interrupts (8 and 9).
+The scaler is configured to 16 bits, while the counters are 32 bits.
+
+1.3 Interrupt controller
+
+The interrupt controller is implemented as described in the
+LEON2 IP manual, with the exception of the interrupt level register.
+Secondary interrupts are not supported. The registers are located
+at address 0x80000090.
+
+1.5 Memory interface
+
+The following memory areas are valid for the Leon3 simulator:
+
+0x00000000 - 0x01000000		ROM (16 Mbyte, loaded at start-up)
+0x40000000 - 0x41000000		RAM (16 Mbyte, loaded at start-up)
+0x80000000 - 0x81000000		APB bus, including plug&play
+0xFFFFF000 - 0xFFFFFFFF		AHB plug&play area
+
+Access to non-existing memory will result in a memory exception trap.
+
+1.8 Power-down mode
+
+The Leon2 power-down register (0x80000018) is supported. When power-down is
+entered, time is skipped forward until the next event in the event queue.
+However, if the simulator event queue is empty, power-down mode is not
+entered since no interrupt would be generated to exit from the mode. A
+Ctrl-C in the simulator window will exit the power-down mode.
diff --git a/sim/erc32/README.sis b/sim/erc32/README.sis
index 22d998b..bf2f7a7 100644
--- a/sim/erc32/README.sis
+++ b/sim/erc32/README.sis
@@ -1,5 +1,5 @@
 
-SIS - Sparc Instruction Simulator README file  (v2.8, 10-11-2014)
+SIS - Sparc Instruction Simulator README file  (v2.8, 07-29-2017)
 -------------------------------------------------------------------
 
 1. Introduction
@@ -13,11 +13,12 @@ and peripherals.
 
 The simulator is started as follows:
 
-sis [-leon3] [-uart1 uart_device1] [-uart2 uart_device2]
-    [-nfp] [-freq frequency] [-c batch_file] [files]
+sis [-leon2] [-leon3] [-uart1 uart_device1] [-uart2 uart_device2]
+    [-nfp] [-freq frequency] [-c batch_file] [-v] [-r] [-tlim time] [files]
 
-By default, SIS emulates an ERC32 system. The -leon3 switch
-enables emulation of a LEON3 SOC system.
+By default, SIS emulates an ERC32 system. The -leon2 switch enables
+LEON2 emulation, while the -leon3 switch enables emulation of a
+LEON3 SOC system.
 
 The emulated console uart is connected to stdin/stdout. The -uart[1,2]
 switch can be used to connect the uarts to other devices.
@@ -31,14 +32,29 @@ The frequency must be an integer indicating the frequency in MHz.
 The -c option indicates that sis commands should be read from 'batch_file'
 at startup.
 
-Files to be loaded must be in one of the supported formats (elf, a.out, srec),
-and will be loaded into the simulated memory.
+-v sets the debug level to 1, to provide some diagnostic messages.
 
-Below is description of commands  that are recognized by
-the simulator. The command-line is parsed using GNU readline. A command
+-r starts execution immediately without an interactive shell. This is useful
+for automated testing of large number of binaries.
+
+-tlim can be used together with -r to limit the amount of simulated time that
+the simulator runs for before exiting. The following units are recognized:
+us, ms and s. To limit simulated time to 100 seconds, it should thus be
+started with -r -tlim 100s .
+
+Files to be loaded must be in one of the formats supported by the BFD library.
+This inlude elf, a.out, srec and binary. On start-up, the files will be
+loaded into the simulated memory.
+
+3. Internal commands
+
+Below is the description of commands that are recognized by the simulator.
+The command-line is parsed using GNU readline. A command
 history of 64 commands is maintained. Use the up/down arrows to recall
 previous commands. For more details, see the readline documentation.
 
+* List of commands:
+
 batch <file>
 
 Execute a batch file of SIS commands.
@@ -124,7 +140,7 @@ Performs a power-on reset. This command is equal to 'run 0'.
 run [inst_count]
 
 Resets the simulator and starts execution from address 0. If an instruction
-count is given (inst_count), the simulator will stop after the specified 
+count is given (inst_count), the simulator will stop after the specified
 number of instructions. The event queue is emptied but any set breakpoints
 remain.
 
@@ -135,148 +151,97 @@ Equal to 'trace 1'
 tra [inst_count]
 
 Starts the simulator at the present position and prints each instruction
-it executes. If an instruction count is given (inst_count), the simulator 
+it executes. If an instruction count is given (inst_count), the simulator
 will stop after the specified number of instructions.
 
-Typing a 'Ctrl-C' will interrupt a running simulator. 
+wmem [addr] [data]
 
-Short forms of the commands are allowed, e.g 'c' 'co' or 'con' are all
-interpreted as 'cont'. 
+Writes [data] to memory at [addr]. Data is written as a 32-bit word.
 
+wp
 
-3. Simulator core
+Prints all watchpoints
 
-In ERC32 mode, SIS emulates the behavior of the 90C601E and 90C602E
-sparc IU and FPU from Matra MHS. These are roughly equivalent to the
-Cypress C601 and C602. The simulator is cycle accurate, i.e a simulator
-time is maintained and incremented according the IU and FPU instruction timing.
-The parallel execution between the IU and FPU is modelled, as well as
-stalls due to operand dependencies (FPU).
++wpr <address>
 
-In Leon3 mode, the core emulates the Leon3 SPARC V8 core from
-Gaisler Research. All SPARC V8 instructions are supported but
-emulation is not fully cycle-true as the cache is not emulated.
+Adds an read watchpoint at address <address>.
+
+-wpr <num>
+
+Deletes read watchpoint <num>. Use 'wp' to see which number is assigned to
+the watchpoints.
+
++wpw <address>
 
-The core interacts with the user-defined memory modules through
-a number of functions. The memory module must provide the following
-functions:
-
-int memory_read(asi,addr,data,ws)
-int asi;
-unsigned int addr;
-unsigned int *data;
-int *ws;
-
-int memory_write(asi,addr,data,sz,ws)
-int asi;
-unsigned int addr;
-unsigned int *data;
-int sz;
-int *ws;
-
-int sis_memory_read(addr, data, length)
-unsigned int addr;
-char   *data;
-unsigned int length;
+Adds an write watchpoint at address <address>.
 
-int sis_memory_write(addr, data, length)
-unsigned int addr;
-char    *data;
-unsigned int length;
+-wpw <num>
 
-int init_sim()
+Deletes write watchpoint <num>. Use 'wp' to see which number is assigned to
+the watchpoints.
 
-int reset()
+Typing a 'Ctrl-C' will interrupt a running simulator.
 
-int error_mode(pc)
-unsigned int pc;
+Short forms of the commands are allowed, e.g 'c' 'co' or 'con' are all
+interpreted as 'cont'.
+
+4. Using SIS with GDB
 
-memory_read() is used by the simulator to fetch instructions and
-operands.  The address space identifier (asi) and address is passed as
-parameters. The read data should be assigned to the data pointer
-(*data) and the number of waitstate to *ws. 'memory_read' should return
-0 on success and 1 on failure. A failure will cause a data or
-instruction fetch trap. memory_read() always reads one 32-bit word.
+To attach GDB to the simulator, use:
 
-sis_memory_read() is used by the simulator to display and disassemble
-memory contants. The function should copy 'length' bytes of the simulated
-memory starting at 'addr' to '*data'.
-The sis_memory_read() should return 1 on success and 0 on failure.
-Failure should only be indicated if access to unimplemented memory is attempted.
+target sim [options]
 
-memory_write() is used to write to memory. In addition to the asi
-and address parameters, the size of the written data is given by 'sz'.
-The pointer *data points to the data to be written. The 'sz' is coded
-as follows:
+The following options are supported:
 
-  sz	access type
-  0	  byte
-  1	  halfword
-  2	  word
-  3	  double-word
+ -leon2         Emulate a LEON2 system
 
-If a double word is written, the most significant word is in data[0] and
-the least significant in data[1].
+ -leon3         Emulate a LEON3 system
 
-sis_memory_write() is used by the simulator during loading of programs.
-The function should copy 'length' bytes from *data to the simulated
-memory starting at 'addr'. sis_memory_write() should return 1 on
-success and 0 on failure. Failure should only be indicated if access
-to unimplemented memory is attempted. See erc32.c for more details
-on how to define the memory emulation functions.
+ -nfp           Disable FPU. FPops will cause an FPU disabled trap.
 
-The 'init_sim' is called once when the simulator is started. This function
-should be used to perform initialisations of user defined memory or
-peripherals that only have to be done once, such as opening files etc.
+ -freq <f>      Set the simulated "system clock" to <f> MHz.
 
-The 'reset' is called every time the simulator is reset, i.e. when a
-'run' command is given. This function should be used to simulate a power
-on reset of memory and peripherals.
+ -v             Verbose mode.
 
-error_mode() is called by the simulator when the IU goes into error mode,
-typically if a trap is caused when traps are disabled. The memory module
-can then take actions, such as issue a reset.
+ -nogdb         Disable GDB breakpoint handling (see below)
 
-sys_reset() can be called by the memory module to reset the simulator. A
-reset will empty the event queue and perform a power-on reset.
+To start debugging a program type 'load <program>' and debug as
+usual.
 
-4. Events and interrupts
+The native simulator commands can be reached using the GDB 'sim'
+command:
 
-The simulator supports an event queue and the generation of processor
-interrupts. The following functions are available to the user-defined
-memory module:
+sim <sis_command>
 
-event(cfunc,arg,delta)
-void (*cfunc)();
-int arg;
-unsigned int delta;
+Direct simulator commands during a GDB session must be issued
+with care not to disturb GDB's operation ...
 
-set_int(level,callback,arg)
-int level;
-void (*callback)();
-int arg;
+A program can be restarted in GDB by first issuing the load command,
+followed by run.
 
-clear_int(level)
-int level;
-
-sim_stop()
+4.1 GDB breakpoint handling
 
-The 'event' functions will schedule the execution of the function 'cfunc'
-at time 'now + delta' clock cycles. The parameter 'arg' is passed as a 
-parameter to 'cfunc'.
+GDB inserts breakpoint in the form of the 'ta 1' instruction. The
+GDB-integrated simulator will therefore recognize the breakpoint
+instruction and return control to GDB. If the application uses
+'ta 1', the breakpoint detection can be disabled with the -nogdb
+switch. In this case however, GDB breakpoints will not work.
 
-The 'set_int' function set the processor interrupt 'level'. When the interrupt
-is taken, the function 'callback' is called with the argument 'arg'. This
-will also clear the interrupt. An interrupt can be cleared before it is
-taken by calling 'clear_int' with the appropriate interrupt level.
 
-The sim_stop function is called each time the simulator stops execution.
-It can be used to flush buffered devices to get a clean state during
-single stepping etc.
+5. Simulator core
+
+In ERC32 mode, SIS emulates the behavior of the 90C601E and 90C602E
+sparc IU and FPU from Matra MHS. These are roughly equivalent to the
+Cypress C601 and C602. The simulator is reasonably cycle accurate, a simulator
+time is maintained and incremented according the IU and FPU instruction timing.
+The parallel execution between the IU and FPU is modelled, as well as
+stalls due to operand dependencies (FPU).
 
-See 'erc32.c' for examples on how to use events and interrupts.
+In Leon2/3 mode, the core emulates the Leon2/3 SPARC V8 core from
+Gaisler Research. All SPARC V8 instructions are supported but
+emulation is not fully cycle-true as the cache is not emulated.
 
-5. Memory module
+6. Memory module
 
 The ERC32 memory module (erc32.c) emulates the functions of memory and
 the MEC asic developed for the 90C601/2. It includes the following functions:
@@ -292,6 +257,19 @@ the MEC asic developed for the 90C601/2. It includes the following functions:
 
 See README.erc32 on how the MEC functions are emulated.
 
+The Leon2 memory module (leon2.c) emulates on-chip peripherals and
+external memory for a simple Leon2 system. The modules includes the
+following functions:
+
+* AHB and APB buses
+* One UART
+* Interrupt controller
+* Timer unit with two timers
+* PROM/SRAM memory controller
+* 16 Mbyte PROM, 16 Mbyte SRAM
+
+See README.leon2 for further details on Leon2 emulation.
+
 The Leon3 memory module (leon3.c) emulates on-chip peripherals and
 external memory for a simple Leon3 system. The modules includes the
 following functions:
@@ -305,57 +283,8 @@ following functions:
 
 See README.leon3 for further details on Leon3 emulation.
 
-6. Compile and linking programs
-
-7. IU and FPU instruction timing.
-
-The simulator provides cycle true simulation for ERC32. The following table
-shows the emulated instruction timing for 90C601E & 90C602E:
-
-Instructions	      Cycles
-
-jmpl, rett		2
-load			2
-store			3
-load double		3
-store double		4
-other integer ops	1
-fabs			2
-fadds			4
-faddd			4
-fcmps			4
-fcmpd			4
-fdivs			20
-fdivd			35
-fmovs			2
-fmuls			5
-fmuld			9
-fnegs			2
-fsqrts			37
-fsqrtd			65
-fsubs			4
-fsubd			4
-fdtoi			7
-fdots			3
-fitos			6
-fitod			6
-fstoi			6
-fstod			2
-
-The parallel operation between the IU and FPU is modelled. This means
-that a FPU instruction will execute in parallel with other instructions as
-long as no data or resource dependency is detected. See the 90C602E data
-sheet for the various types of dependencies. Tracing using the 'trace'
-command will display the current simulator time in the left column. This
-time indicates when the instruction is fetched. If a dependency is detetected,
-the following fetch will be delayed until the conflict is resolved.
-
-The load dependency in the 90C601E is also modelled - if the destination 
-register of a load instruction is used by the following instruction, an 
-idle cycle is inserted.
-
-8. FPU implementation
+7. FPU implementation
 
 The simulator maps floating-point operations on the hosts floating point
-capabilities. This means that accuracy and generation of IEEE exceptions is 
+capabilities. This means that accuracy and generation of IEEE exceptions is
 host dependent.
diff --git a/sim/erc32/erc32.c b/sim/erc32/erc32.c
index 3ab70c2..cc74fad 100644
--- a/sim/erc32/erc32.c
+++ b/sim/erc32/erc32.c
@@ -24,7 +24,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <termios.h>
-#include <sys/fcntl.h>
+#include <fcntl.h>
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
diff --git a/sim/erc32/interf.c b/sim/erc32/interf.c
index ff68259..3baf165 100644
--- a/sim/erc32/interf.c
+++ b/sim/erc32/interf.c
@@ -21,7 +21,7 @@
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/fcntl.h>
+#include <fcntl.h>
 #include "sis.h"
 #include "libiberty.h"
 #include "bfd.h"
diff --git a/sim/erc32/leon2.c b/sim/erc32/leon2.c
index 87bee6a..231fa7a 100644
--- a/sim/erc32/leon2.c
+++ b/sim/erc32/leon2.c
@@ -27,7 +27,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <termios.h>
-#include <sys/fcntl.h>
+#include <fcntl.h>
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
diff --git a/sim/erc32/leon3.c b/sim/erc32/leon3.c
index 4f35386..ce2851a 100644
--- a/sim/erc32/leon3.c
+++ b/sim/erc32/leon3.c
@@ -28,7 +28,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <termios.h>
-#include <sys/fcntl.h>
+#include <fcntl.h>
 #include <sys/file.h>
 #include <unistd.h>
 #include "sis.h"
diff --git a/sim/erc32/sis.c b/sim/erc32/sis.c
index 83dd5cf..85f105b 100644
--- a/sim/erc32/sis.c
+++ b/sim/erc32/sis.c
@@ -23,7 +23,7 @@
 #include <stdlib.h>
 #endif
 #include <stdio.h>
-#include <sys/fcntl.h>
+#include <fcntl.h>
 #include "sis.h"
 #include <dis-asm.h>
 #include "sim-config.h"
